package ui.medium {
	import ui.IButton;
	import ui.IButtonObserver;
	import ui.IPlayerControls;
	import ui.IPlayerControlsObserver;
	import ui.ImageButton;
	
	import flash.display.Sprite;	

	/**
     * @author bram
     */
    public class PlayerControls extends Sprite implements IButtonObserver, IPlayerControls
    {
    	private var _observers : Vector.<IPlayerControlsObserver>;
        
        [Embed(source='../../../media/play_pause_icon_small.png')]
        private var PlayButtonImage : Class;
        private var _playButton : ImageButton;

        [Embed(source='../../../media/loop_icon_small.png')]
        private var LoopButtonImage : Class;
        private var _loopButton : ImageButton;

        private var _maxHeight:int = 0;
        private var _maxWidth:int = 0;

        public function PlayerControls()
        {
        	_observers = new Vector.<IPlayerControlsObserver>();

            _playButton = new ImageButton(new PlayButtonImage(), 4, true);
            _playButton.addButtonObserver(this);
            _playButton.x = 0;
            _playButton.y = 0;
            addChild(_playButton);
            
			_loopButton = new ImageButton(new LoopButtonImage(), 4, true);
            _loopButton.addButtonObserver(this);
            _loopButton.x = _playButton.width;
            _loopButton.y = 0;
            addChild(_loopButton);

            _maxHeight = Math.max(_playButton.getSize().height, _loopButton.getSize().height);
            _maxWidth = _loopButton.x + _loopButton.getSize().width;
        }

        public function setPlayButtonState(playing:Boolean) : void
        {
            _playButton.setState(playing);
        }

        public function addPlayerControlsObserver(observer:IPlayerControlsObserver):void
        {
        	_observers.push(observer);
        }
        
        public function getMaxHeight():int
        {
        	return _maxHeight;
        }
        
        public function getMaxWidth():int
        {
			return _maxWidth;
        }
        
        public function onButtonDown(button : IButton) : void
        {
        	for each (var observer:IPlayerControlsObserver in _observers)
        	{
	            switch (button)
	            {
	                case _playButton: observer.playClicked(this); break;
			        case _loopButton: observer.loopOnClicked(this); break;
	            }
        	}
        }
        
        public function onButtonUp(button:IButton):void
        {
        	for each (var observer:IPlayerControlsObserver in _observers)
        	{
	            switch (button)
	            {
	                case _playButton: observer.pauseClicked(this); break;
			        case _loopButton: observer.loopOffClicked(this); break;
	            }
        	}
        }
    }
}
