# -*- coding: utf-8 -*-
# Generated by Django 1.11 on 2017-07-07 10:56
from __future__ import unicode_literals

from django.db import migrations, models


def create_instance(apps, schema_editor):
    DonationsModalSettings = apps.get_model("donations", "DonationsModalSettings")
    DonationsModalSettings.objects.create()


class Migration(migrations.Migration):

    dependencies = [
        ('donations', '0002_auto_20170116_1704'),
    ]

    operations = [
        migrations.CreateModel(
            name='DonationsModalSettings',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('enabled', models.BooleanField(default=False)),
                ('days_after_donation', models.PositiveIntegerField(default=365, help_text='If user made a donation in the last X days, no modal is shown')),
                ('downloads_in_period', models.PositiveIntegerField(default=5, help_text='After user has download Z sounds...')),
                ('download_days', models.PositiveIntegerField(default=7, help_text='...in Y days, we display the modal')),
                ('display_probability', models.FloatField(default=0.25, help_text='probabily of the modal being shown once all previous requirements are met')),
                ('max_times_display_a_day', models.PositiveIntegerField(default=10, help_text='max number of times we display the modal during a single day')),
            ],
        ),
        migrations.RunPython(create_instance, migrations.RunPython.noop)
    ]
